package com.baofoo.Demo;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.baofoo.Entity.PostMasterEntity;
import com.baofoo.Entity.ResultMasterEntity;
import com.baofoo.rsa.JHSignatureUtils;
import com.baofoo.rsa.JuheRSA;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;
import com.baofoo.util.TripleDes;

import net.sf.json.JSONObject;
/**
 * 提交商户开户申请
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2024年3月27日
 * 以下DEMO仅供参考，具体参数以方案对应的文档为准
 * 本方法默认使用国际算法加签加密
 */
public class Merchant_Confirm{
	
	public static void main(String[] args) throws Exception {
		String  pfxpath ="D:\\CER_EN_DECODE\\AgreementPay\\bfkey_100025773@@200001173.pfx";//商户私钥        
        String  cerpath = "D:\\CER_EN_DECODE\\AgreementPay\\bfkey_100025773@@200001173.cer";//宝付公钥
        String 	pfxpwd = "100025773_286941";//私钥密码
        
        String merId="100025773";
        String terId="200001173";
        String Method = "merchant_confirm";
        
        String subMchId="400935526";//商户识别码/微信、支付宝二级商户
        
        String Deskey=TripleDes.generateKey();///FormatUtil.CreateAeskey(24)+FormatUtil.CreateAeskey(24);///DES key   48个字符
        
        Log.Write("密码："+Deskey);
        
        String MerchantConfirmNo="RN"+FormatUtil.CreateAeskey(15);//口唯一编号
        Log.Write("商户认证单号："+MerchantConfirmNo);


        Map<String,Object> Biz_Content = new HashMap<String,Object>();
        Biz_Content.put("agentMerId", "");
        Biz_Content.put("agentTerId", "");
        Biz_Content.put("merId", merId);
        Biz_Content.put("terId", terId);
        Biz_Content.put("subMchId", subMchId);
        Biz_Content.put("merchantConfirmNo", MerchantConfirmNo);
        
        
        Map<String,Object> MerchantConfirmInfo = new HashMap<String,Object>();
        ///以下参数实列以最小提交，商户请以文档为准按商户业务提交相应参数
        
        ///商户联系人信息：contact_info
        Map<String,String> ContactInfo = new HashMap<String,String>();
        ///本示例以法人为准，如果为经办人请参看文档上传其他参数
        ContactInfo.put("contact_type", "LEGAL");//联系人类型
        ContactInfo.put("name", SecurityUtil.DesEn("双彦飞", Deskey));//联系人姓名
        ContactInfo.put("mobile", SecurityUtil.DesEn("16821778660", Deskey));//联系人手机号
        
        ///主体信息：subject_info
        Map<String,Object> SubjectInfo = new HashMap<String,Object>();
        ///本示例以企业为准，如果是其他类型请参看接口文档中参数。
        SubjectInfo.put("subject_type", "SUBJECT_TYPE_ENTERPRISE");
        	///营业执照信息
        	Map<String,Object> BusinessLicenceInfo = new HashMap<String,Object>();
        	BusinessLicenceInfo.put("licence_number", "92510923MABYHTCG7D");
        	BusinessLicenceInfo.put("licence_copy", "8f5c47a9382d410eb87e2cdd8057e3d7");///上传图片接口返回的MediaID
        	BusinessLicenceInfo.put("merchant_name", "上海商城测试有限公司");
        	BusinessLicenceInfo.put("legal_person", "双彦飞");
        	BusinessLicenceInfo.put("company_address", "上海市浦东新区张江镇居里路99号");
	        	List<String> LicenceValidDate = new ArrayList<String>();////营业执照有效日期
	        	LicenceValidDate.add("2020-10-28");
	        	LicenceValidDate.add("2040-10-28");
        	BusinessLicenceInfo.put("licence_valid_date", LicenceValidDate);
        	
        SubjectInfo.put("business_licence_info", BusinessLicenceInfo);
        
                
        ///法人身份信息：identification_info
        Map<String,Object> IdentificationInfo = new HashMap<String,Object>();
        ///本示例以法人为参数，如果其他情况请参看接口文档，
        IdentificationInfo.put("identification_type", "IDENTIFICATION_TYPE_IDCARD");
        IdentificationInfo.put("identification_name", SecurityUtil.DesEn("双彦飞", Deskey));
        IdentificationInfo.put("identification_number", SecurityUtil.DesEn("340102200001010458", Deskey));
        List<String> identificationValidDate = new ArrayList<String>();//证件有效日期
        identificationValidDate.add("2020-10-28");
        identificationValidDate.add("forever");
        IdentificationInfo.put("identification_valid_date", identificationValidDate);
        IdentificationInfo.put("identification_address", SecurityUtil.DesEn("上海市浦东新区张江镇居里路99号", Deskey));
        
    	
        IdentificationInfo.put("identification_front_copy", "8f5c47a9382d410eb87e2cdd8057e3d7");
        IdentificationInfo.put("identification_back_copy", "8f5c47a9382d410eb87e2cdd8057e3d7");
        
                
        ///最终受益人信息列表(UBO)：ubo_info_list    
        List<Map<String,String>> UboInfoListAll = new ArrayList<>();
        ///测试以法人为实列，如果是其他情况请参看接口文档上送对应参数。
        Map<String,String> UboInfoList1 = new HashMap<String,String>();
        
        UboInfoList1.put("ubo_id_doc_type", "IDENTIFICATION_TYPE_IDCARD");
        UboInfoList1.put("ubo_id_doc_copy", "8f5c47a9382d410eb87e2cdd8057e3d7");
        UboInfoList1.put("ubo_id_doc_copy_back", "8f5c47a9382d410eb87e2cdd8057e3d7");
        UboInfoList1.put("ubo_id_doc_name", SecurityUtil.DesEn("双彦飞", Deskey));
        UboInfoList1.put("ubo_id_doc_number", SecurityUtil.DesEn("340102200001010458", Deskey));
        UboInfoList1.put("ubo_id_doc_address", SecurityUtil.DesEn("上海市浦东新区张江镇居里路99号", Deskey));
        UboInfoList1.put("ubo_period_begin", "2020-10-28");
        UboInfoList1.put("ubo_period_end", "2040-10-28");
        
        UboInfoListAll.add(UboInfoList1);
        MerchantConfirmInfo.put("contact_info", ContactInfo);
        MerchantConfirmInfo.put("subject_info", SubjectInfo);
        MerchantConfirmInfo.put("identification_info", IdentificationInfo);
        MerchantConfirmInfo.put("ubo_info_list", UboInfoListAll);
        
        
        Biz_Content.put("merchantConfirmInfo", MerchantConfirmInfo);
        
        
        PostMasterEntity pme = new PostMasterEntity();
        String BizContent=JSONObject.fromObject(Biz_Content).toString();
        Log.Write(BizContent);
        
        String BizContentEn =JHSignatureUtils.encryptByRSA(BizContent, pfxpath, pfxpwd);
        
        pme.setBizContent(BizContent);
        pme.setSignStr(BizContentEn);
        
        pme.setMerId(merId);
        pme.setTerId(terId);
        pme.setMethod(Method);
        
        String DgtlEnvlp=JuheRSA.encrypt(SecurityUtil.hex2Bytes(Deskey), cerpath);//JuHeRsaCodingUtil.encryptByPubCerFile(Deskey, cerpath);
        pme.setDgtlEnvlp(DgtlEnvlp);
        Log.Write(pme.getParmFormat());
        
        String PostString  = HttpUtil.RequestForm("https://mch-juhe.baofoo.com/mch-service/api",pme.getMap());
        
       Log.Write(PostString);
        ResultMasterEntity rme = (ResultMasterEntity) JSONObject.toBean(JSONObject.fromObject(PostString), ResultMasterEntity.class);
        
        Log.Write(rme.toString());
        
        if(JHSignatureUtils.verifySignature(cerpath, rme.getDataContent(), rme.getSignStr())){
        	Log.Write("YES");
        }else{
        	Log.Write("NO");
        }
        /***
         * 
         * ......
         * 
         */
        
	}
}

