package com.baofoo.Demo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.baofoo.Entity.PostMasterEntity;
import com.baofoo.Entity.ResultMasterEntity;
import com.baofoo.rsa.JHSignatureUtils;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;


import net.sf.json.JSONObject;
/**
 * 报备认证
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2024年3月25日
 */
public class Merchant_Report{
	
	public static void main(String[] args) throws Exception {
		String  pfxpath ="D:\\CER_EN_DECODE\\AgreementPay\\bfkey_100025773@@200001173.pfx";//商户私钥        
        String  cerpath = "D:\\CER_EN_DECODE\\AgreementPay\\bfkey_100025773@@200001173.cer";//宝付公钥
        String 	pfxpwd = "100025773_286941";//私钥密码
        
        String Method = "merchant_report";
        
        String merId="100025773";
        String terId="200001173";
        
        String ReportType="WECHAT";//WECHAT/ALIPAY        
        String bctMerId="";//宝财通二级商户号必上传,其他非宝财通不上送
        
        
        String MerchantName="上海商城测试有限公司";//该名称是公司主体全称
        String MerchantShortname="宝付测试商店";//该名称是显示给消费者看的商户名称
        
        String BusinessLicense="92510923MABYHTCG7D";//商户证件编号（企业或者个体工商户提供营业执照，事业单位提供事证号，小微商户提供身份证号）
        String BusinessLicenseType="NATIONAL_LEGAL";//NATIONAL_LEGAL	营业执照,NATIONAL_LEGAL_MERGE	营业执照(多证合一),INST_RGST_CTF	事业单位法人证书,IDENTITY_CARD	个人身份证,OTHERS	其他
        String ServicePhone="16021798660";//客服电话  方便银联在必要时能联系上商家
        
        String ChannelId="235513482";//微信服务商ID
        String ChannelName="上海测试科技有限公司";//微信服务商商户名称
        String business="758-2";//行业类目，请填写对应的ID
        
        String ContactWechatid="";//联系人微信帐号 非必传，
        
        ///编码是与国家统计局一致，请查询 :http://www.stats.gov.cn/sj/tjbz/tjyqhdmhcxhfdm/2022/index.html
        String CityCode="310100";//城市编码
        String DistrictCode="310115";//区县编码
        String ProvinceCode="310000";//省份编码
        String Address="居里路99号";//详细地址	
        
        ////银行卡信息：bankcard_info
        String CardNo="9212262201024356";///银行卡号
        String CardName="上海测试科技有限公司";///银行卡持卡人姓名
        
        String ReportNo="RN"+FormatUtil.CreateAeskey(15);//每次请求报备接口唯一编号
        Log.Write("请求流水号："+ReportNo);
        
        Map<String,Object> Biz_Content = new HashMap<String,Object>();
        Biz_Content.put("merId", merId);
        Biz_Content.put("terId", terId);
        
        Biz_Content.put("reportType", ReportType);        
        Biz_Content.put("reportNo", ReportNo);//每次请求报备接口唯一编号
        
        //Biz_Content.put("bctMerId", bctMerId);//开通有宝财通二级商户号必需上传
        
        
        
        ///报备信息参数：reportInfo
        Map<String,Object> ReportInfo = new HashMap<String,Object>();        
        ReportInfo.put("merchant_name", MerchantName);
        ReportInfo.put("merchant_shortname", MerchantShortname);
        ReportInfo.put("service_phone", ServicePhone);
        ReportInfo.put("channel_id", ChannelId);
        ReportInfo.put("channel_name", ChannelName);
        ReportInfo.put("business", business);
        
        if(!ContactWechatid.isEmpty()) {//如传微信号，值为 type_wechatid
        	ReportInfo.put("contact_wechatid", ContactWechatid);
            ReportInfo.put("contact_wechatid_type", "type_wechatid");
        }
        
        List<String> ServiceCodes=new ArrayList<String>();        
        ServiceCodes.add("JSAPI");//申请服务，可传送所有需要开通的服务
        ServiceCodes.add("APPLET");
        
        ReportInfo.put("service_codes", ServiceCodes);
        
        
        ///地址信息：address_info
        Map<String,String> AddressInfo = new HashMap<String,String>();    
        AddressInfo.put("city_code", CityCode);
        AddressInfo.put("district_code", DistrictCode);
        AddressInfo.put("province_code", ProvinceCode);
        AddressInfo.put("address", Address);
        
        ReportInfo.put("address_info", AddressInfo);
        
        ReportInfo.put("business_license", BusinessLicense);
        ReportInfo.put("business_license_type", BusinessLicenseType);
        
        ///银行卡信息：bankcard_info
        Map<String,String> BankcardInfo = new HashMap<String,String>();   
        BankcardInfo.put("card_no", CardNo);
        BankcardInfo.put("card_name", CardName);      
        
        ReportInfo.put("bankcard_info", BankcardInfo);
        
        Biz_Content.put("reportInfo", ReportInfo);//仅开通有宝财通二级商户号上传
               
                
        PostMasterEntity pme = new PostMasterEntity();
        
        
        String BizContent=JSONObject.fromObject(Biz_Content).toString();
        Log.Write("请求报文："+BizContent);
        
        String BizContentEn =JHSignatureUtils.encryptByRSA(BizContent, pfxpath, pfxpwd);
        
        pme.setBizContent(BizContent);
        pme.setSignStr(BizContentEn);        
        pme.setMerId(merId);
        pme.setTerId(terId);
        pme.setMethod(Method);
        
        String PostString  = HttpUtil.RequestForm("https://mch-juhe.baofoo.com/mch-service/api",pme.getMap());
        
       Log.Write("返回："+PostString);
        ResultMasterEntity rme = (ResultMasterEntity) JSONObject.toBean(JSONObject.fromObject(PostString), ResultMasterEntity.class);
        
        Log.Write(rme.toString());
        
        if(JHSignatureUtils.verifySignature(cerpath, rme.getDataContent(), rme.getSignStr())){
        	Log.Write("YES");
        }else{
        	Log.Write("NO");
        }
        /***
         * 
         * ......
         * 
         */
        
	}
}

