package com.baofoo.Demo;

import java.util.HashMap;
import java.util.Map;

import com.baofoo.Entity.PostMasterEntity;
import com.baofoo.Entity.ResultMasterEntity;
import com.baofoo.rsa.JHSignatureUtils;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;


import net.sf.json.JSONObject;
/**
 * 报备交易查询
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2024年3月26日
 */
public class Merchant_Report_Query{
	
	public static void main(String[] args) throws Exception {
		String  pfxpath ="D:\\CER_EN_DECODE\\AgreementPay\\bfkey_100025773@@200001173.pfx";//商户私钥        
        String  cerpath = "D:\\CER_EN_DECODE\\AgreementPay\\bfkey_100025773@@200001173.cer";//宝付公钥
        String 	pfxpwd = "100025773_286941";//私钥密码
        
        
        
        String merId="100025773";
        String terId="200001173";
        
        String ReportType="WECHAT";//WECHAT/ALIPAY   
        String Method = "merchant_report_query";        
        String ReportNo="RNDEC0DCA83C91B33";//原报备的流水号


        Map<String,Object> Biz_Content = new HashMap<String,Object>();
        Biz_Content.put("merId", merId);
        Biz_Content.put("terId", terId);
        Biz_Content.put("reportType", ReportType);
        Biz_Content.put("reportNo", ReportNo);
                
        PostMasterEntity pme = new PostMasterEntity();        
        
        String BizContent=JSONObject.fromObject(Biz_Content).toString();
        Log.Write(BizContent);
        
        String BizContentEn =JHSignatureUtils.encryptByRSA(BizContent, pfxpath, pfxpwd);
        
        pme.setBizContent(BizContent);
        pme.setSignStr(BizContentEn);
        
        pme.setMerId(merId);
        pme.setTerId(terId);
        pme.setMethod(Method);
        
        String PostString  = HttpUtil.RequestForm("https://mch-juhe.baofoo.com/mch-service/api",pme.getMap());
        
       Log.Write(PostString);
        ResultMasterEntity rme = (ResultMasterEntity) JSONObject.toBean(JSONObject.fromObject(PostString), ResultMasterEntity.class);
        
        Log.Write(rme.toString());
        
        if(JHSignatureUtils.verifySignature(cerpath, rme.getDataContent(), rme.getSignStr())){
        	Log.Write("YES");
        }else{
        	Log.Write("NO");
        }
        /***
         * 
         * ......
         * 
         */
        
	}
}

